import { FC, ReactElement } from 'react';
import { InputProps } from '../Input/input';
interface DataSourceObject {
    value: string;
}
export declare type DataSourceType<T = {}> = T & DataSourceObject;
export interface AutoCompleteProps extends Omit<InputProps, 'onSelect'> {
    /**
     * 返回关联数据
     */
    fetchSuggestions: (str: string) => DataSourceType[] | Promise<DataSourceType[]>;
    /**
     * 选择数据其中一项
     */
    onSelect?: (item: DataSourceType) => void;
    /**
     * 自定义模版
     */
    renderOption?: (item: DataSourceType) => ReactElement;
}
/**
 * ## 引用方法
 * ~~~js
 * import {AutoComplete} from 'wsq'
 * ~~~
 */
export declare const AutoComplete: FC<AutoCompleteProps>;
export default AutoComplete;
