import React, { FC, ButtonHTMLAttributes, AnchorHTMLAttributes } from 'react';
export declare type ButtonSize = 'lg' | 'sm';
export declare type ButtonType = 'primary' | 'default' | 'danger' | 'link';
interface BaseButtonProps {
    /**
     * 设置button类名
     */
    className?: string;
    /**
     * 设置button的禁用
     */
    disabled?: boolean;
    /**
     * 设置button的大小
     */
    size?: ButtonSize;
    /**
     * 设置button的类型
     */
    btnType?: ButtonType;
    children: React.ReactNode;
    href?: string;
}
declare type NativeButtonProps = BaseButtonProps & ButtonHTMLAttributes<HTMLElement>;
declare type AnchorButtonProps = BaseButtonProps & AnchorHTMLAttributes<HTMLElement>;
export declare type ButtonProps = Partial<NativeButtonProps & AnchorButtonProps>;
/**
 * ## 引用方法
 * ~~~js
 * import {Button} from 'wsq'
 * ~~~
 */
export declare const Button: FC<ButtonProps>;
export default Button;
