import React, { FC, InputHTMLAttributes, ReactElement, ChangeEvent } from 'react';
import { IconProp } from '@fortawesome/fontawesome-svg-core';
export interface InputProps extends Omit<InputHTMLAttributes<HTMLElement>, 'size'> {
    /**
     * 设置input类名
     */
    className?: string;
    /**
     * 设置input的禁用
     */
    disabled?: boolean;
    /**
     * 设置input的大小
     */
    size?: 'lg' | 'sm';
    /**
     * 设置input的icon
     */
    icon?: IconProp;
    prepend?: string | ReactElement;
    append?: string | ReactElement;
    style?: React.CSSProperties;
    onChange?: (e: ChangeEvent<HTMLInputElement>) => void;
}
/**
 * ## 引用方法
 * ~~~js
 * import {Input} from 'wsq'
 * ~~~
 */
export declare const Input: FC<InputProps>;
export default Input;
