import React, { useContext } from 'react';
import classNames from 'classnames';
import { MenuContext } from './menu';
var MenuItem = function (props) {
    var 
    // 取出className
    className = props.className, index = props.index, disabled = props.disabled, style = props.style, children = props.children;
    // 获取父组件传来的值
    var context = useContext(MenuContext);
    // 用户有自定义classname 就把它放进去
    var classes = classNames('menu-item', className, {
        'is-disabled': disabled,
        'is-active': context.index === index
    });
    // 定义菜单项点击事件
    var handleClick = function () {
        // 如果父组件有传点击事件且菜单没被禁用，就执行父组件传来的点击事件 把当前的index传给父组件
        if (context.onSelect && !disabled && (typeof index === 'string')) {
            context.onSelect(index);
        }
    };
    return (React.createElement("li", { className: classes, style: style, onClick: handleClick },
        children,
        " - ",
        index));
};
MenuItem.defaultProps = {
    index: '0',
    disabled: false
};
// react 内置属性
MenuItem.displayName = 'MenuItem';
export default MenuItem;
