var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import React, { useState, useContext } from 'react';
import Transition from '../Transition/transition';
import classNames from 'classnames';
import { MenuContext } from './menu';
import Icon from '../Icon/icon';
var SubMenu = function (_a) {
    var index = _a.index, title = _a.title, children = _a.children, className = _a.className;
    //获取父节点传递的数据
    var context = useContext(MenuContext);
    //将父组件传过来的 defaultOpenSubMenus断言成数组，undefined没有用处
    var openedSubMenus = context.defaultOpenSubMenus;
    // 如果index存在且是纵向菜单且openedSubMenus包含index 则展开此菜单
    var isOpend = (index && context.mode === 'vertical') ? openedSubMenus.includes(index) : false;
    // 控制子菜单展开与否
    var _b = useState(isOpend), menuOpen = _b[0], setOpen = _b[1];
    var classes = classNames('menu-item submenu-item', className, {
        'is-active': context.index.includes('-'),
        'is-opened': menuOpen,
        'is-vertical': context.mode === 'vertical'
    });
    // 定义点击一级菜单点击事件
    var handleClick = function (e) {
        e.preventDefault();
        setOpen(!menuOpen);
    };
    // 定义点击一级菜单鼠标经过事件
    var timer;
    var handleMouse = function (e, toggle) {
        clearTimeout(timer);
        e.preventDefault();
        timer = setTimeout(function () {
            setOpen(toggle);
        }, 300);
    };
    // 如果菜单是纵向的， 则赋上鼠标点击事件
    var clickEvents = context.mode === 'vertical' ? handleClick : undefined;
    // 如果菜单是横向的， 则赋上鼠标经过事件
    var hoverEvents = context.mode !== 'vertical' ? {
        onMouseEnter: function (e) { handleMouse(e, true); },
        onMouseLeave: function (e) { handleMouse(e, false); }
    } : {};
    // 返回 ul li结构
    var renderChildren = function () {
        var subMenuClasses = classNames('wsq-submenu', {
            'menu-opened': menuOpen
        });
        var childrenComponent = React.Children.map(children, function (child, i) {
            var childElement = child;
            if (childElement.type.displayName === 'MenuItem') {
                return React.cloneElement(childElement, {
                    index: "".concat(index, "-").concat(i)
                });
            }
            else {
                console.error('warning: menu has a child');
            }
        });
        return (React.createElement(Transition, { in: menuOpen, timeout: 300, animation: "zoom-in-bottom" },
            React.createElement("ul", { className: subMenuClasses }, childrenComponent)));
    };
    // 返回 最终结构<li><div>title</div> <ul><li>子菜单一</li><li>子菜单二</li></ul> </li> 
    return (React.createElement("li", __assign({ key: index, className: classes }, hoverEvents),
        React.createElement("div", { className: 'submenu-title', onClick: clickEvents },
            title,
            React.createElement(Icon, { icon: "angle-down", className: "arrow-icon" })),
        renderChildren()));
};
SubMenu.displayName = 'SubMenu';
export default SubMenu;
