import React, { useState, createContext } from 'react';
import classNames from 'classnames';
// 创建上下文
export var TabsContext = createContext({ index: '0' });
// Tabs组件
var Tabs = function (props) {
    // 取出属性
    var className = props.className, mode = props.mode, defaultIndex = props.defaultIndex, style = props.style, children = props.children;
    var _a = useState(defaultIndex), currentIndex = _a[0], setIndex = _a[1];
    // 定义class className是用户传来的classname 跟我们自己定义的合并起来
    var classes = classNames('wsq-tabs', className, {
        'tabs-round': mode === 'round',
        'tabs-normal': mode !== 'round'
    });
    // 传给子组件的点击事件（点击子组件）
    var handleCilck = function (index) {
        setIndex(index);
    };
    // 传给子组件的数据
    var passedContext = {
        index: currentIndex ? currentIndex : '0',
        onSelect: handleCilck
    };
    // 遍历子组件 给子组件赋值index
    var renderChildren = function () {
        return React.Children.map(children, function (c, i) {
            var childElement = c;
            var displayName = childElement.type.displayName;
            if (displayName === 'TabsItem') {
                return React.cloneElement(childElement, {
                    index: i.toString()
                });
            }
            else {
                console.error('warning: tabs has a child');
            }
        });
    };
    // 返回的结构
    return (React.createElement("ul", { className: classes, style: style },
        React.createElement(TabsContext.Provider, { value: passedContext }, renderChildren())));
};
Tabs.defaultProps = {
    defaultIndex: '0',
    mode: 'normal'
};
export default Tabs;
