import React, { useContext } from 'react';
import classNames from 'classnames';
import { TabsContext } from './tabs';
var TabsItem = function (props) {
    // 取出属性
    var className = props.className, index = props.index, style = props.style, disabled = props.disabled, children = props.children;
    // 定义classname
    // 获取父组件传来的值
    var context = useContext(TabsContext);
    var classes = classNames('tabs-item', className, {
        'is-disabled': disabled,
        'is-active': context.index === index
    });
    var handleClick = function () {
        if (context.onSelect && !disabled && typeof index === 'string') {
            context.onSelect(index);
        }
    };
    return (React.createElement("li", { className: classes, style: style, onClick: handleClick }, children));
};
TabsItem.defaultProps = {
    index: '0',
    disabled: false
};
TabsItem.displayName = 'TabsItem';
export default TabsItem;
