import { useEffect } from "react";
function useClickOutside(ref, handler) {
    useEffect(function () {
        var listener = function (event) {
            console.log(ref.current);
            console.log(event.target);
            // ref.current 传进来的dom
            // event.target 用户点击的dom
            // 如果用户点击的位置 是在传进来的dom里面 那就return
            // 如果用户点击的位置超出传进来的dom 则执行回调函数 将点击的地方传出去
            if (!ref.current || ref.current.contains(event.target)) {
                return;
            }
            handler(event);
        };
        // 给整个页面添加此点击事件
        document.addEventListener('click', listener);
        return function () {
            // 清除副作用
            document.removeEventListener('click', listener);
        };
    }, [ref, handler]);
}
export default useClickOutside;
